/*===========================================================================


       about.cpp -  about panel form code
       
                    Copyright  2001, 2003 by Pankhurst Algorithmics
                    (www.pankhurst.com, www.ebmDevMag.com)
                    All Rights Reserved


 ** LICENSE ********************************************************************
 *                                                                             *
 *  Version: MPL 1.1                                                           *
 *                                                                             *
 *  The contents of this file are subject to the Mozilla Public License        *
 *  Version 1.1 (the "License"); you may not use this file except in           *
 *  compliance with the License. You may obtain a copy of the License at       *
 *  http://www.mozilla.org/MPL/                                                *
 *                                                                             *
 *  Software distributed under the License is distributed on an "AS IS" basis, *
 *  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   *
 *  for the specific language governing rights and limitations under the       *
 *  License.                                                                   *
 *                                                                             *
 *  The Original Code is: eBookMan Form Editor                                 *
 *                                                                             *
 *  The Initial Developer of the Original Code is                              *
 *  Pankhurst Algorithmics                                                     *
 *                                                                             *
 *  Portions created by the Initial Developer are Copyright (C) 2001-2003      *
 *  Pankhurst Algorithmics. All Rights Reserved.                               *
 *                                                                             *
 *                                                                             *
 *******************************************************************************


===========================================================================*/
#include <vcl.h>
#pragma hdrstop

#include "about.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TAboutBox *AboutBox;
//---------------------------------------------------------------------
__fastcall TAboutBox::TAboutBox(TComponent* AOwner)
	: TForm(AOwner)
{
  char buff[256]="Version ", path[256]="", *ptr=buff;
  ::GetModuleFileName(NULL,path,sizeof(path));
  GetFileVersionInformation(path,&buff[strlen(buff)]);
  // reduce version number to 1.02 style by stripping form second '.' on
  if ( NULL != (ptr=strchr(ptr+1,'.')) && NULL != (ptr=strchr(ptr+1,'.')) )
    *ptr='\0';
  strcat(buff," (" __DATE__ ")"); // add compile date
  Version->Caption=buff;
}
//---------------------------------------------------------------------
void __fastcall TAboutBox::ProgramIconClick(TObject *Sender)
{
  // go to website
  ::ShellExecute(NULL,"OPEN","http://www.pankhurst.com/",NULL,"",SW_SHOW);
}
//---------------------------------------------------------------------------
void TAboutBox::GetFileVersionInformation(const char *filePath,char *buff)
{
  // get version string from exe
  DWORD dwVerHnd=0;
  DWORD dwVerInfoSize=GetFileVersionInfoSize((char*)filePath,&dwVerHnd);
  if (dwVerInfoSize)
  {
    HANDLE hMem=GlobalAlloc(GMEM_MOVEABLE,dwVerInfoSize);
    LPVOID lpvMem=GlobalLock(hMem);
    GetFileVersionInfo((char*)filePath, dwVerHnd, dwVerInfoSize, lpvMem);
    UINT cchVer=0;
    LPVOID lszVer = NULL;
    bool fRet=VerQueryValue(lpvMem,
                            TEXT("\\StringFileInfo\\040904E4\\FileVersion"),
                            &lszVer,
                            &cchVer);
    if (fRet && cchVer && lszVer)
      lstrcpy(buff,(char*)lszVer);
    else
      buff[0]='\0';
    GlobalUnlock(hMem);
    GlobalFree(hMem);
  }
}
//---------------------------------------------------------------------------

