/*===========================================================================


       dlgcpp.cpp - dialog to handle code output settings when writing file

                    Copyright  2001, 2003 by Pankhurst Algorithmics
                    (www.pankhurst.com, www.ebmDevMag.com)
                    All Rights Reserved


 ** LICENSE ********************************************************************
 *                                                                             *
 *  Version: MPL 1.1                                                           *
 *                                                                             *
 *  The contents of this file are subject to the Mozilla Public License        *
 *  Version 1.1 (the "License"); you may not use this file except in           *
 *  compliance with the License. You may obtain a copy of the License at       *
 *  http://www.mozilla.org/MPL/                                                *
 *                                                                             *
 *  Software distributed under the License is distributed on an "AS IS" basis, *
 *  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   *
 *  for the specific language governing rights and limitations under the       *
 *  License.                                                                   *
 *                                                                             *
 *  The Original Code is: eBookMan Form Editor                                 *
 *                                                                             *
 *  The Initial Developer of the Original Code is                              *
 *  Pankhurst Algorithmics                                                     *
 *                                                                             *
 *  Portions created by the Initial Developer are Copyright (C) 2001-2003      *
 *  Pankhurst Algorithmics. All Rights Reserved.                               *
 *                                                                             *
 *                                                                             *
 *******************************************************************************


===========================================================================*/
#include <vcl.h>
#pragma hdrstop

#include "formgrp.h"

#include "dlgCpp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TdlgCodeSettings *dlgCodeSettings;
//---------------------------------------------------------------------------
__fastcall TdlgCodeSettings::TdlgCodeSettings(TComponent* Owner)
        : TForm(Owner)
{
  Label1->Caption="";
}
//---------------------------------------------------------------------------
bool TdlgCodeSettings::Execute(CFormGroup *obj,bool silentMode)
{
  // open dialog for setting changes before writing file - return success flag
  if (!silentMode)
  {
    if (mrOk!=ShowModal())
      return false;
  }
  if (RADIO_USECLIPBOARD->Checked)
    return obj->OutputCPPSourceCode(NULL,CHECK_UNIXSTYLE->Checked,!CHECK_INCLUDEMAIN->Checked);
  if (RADIO_USEFILE->Checked)
    return obj->OutputCPPSourceCode(Label1->Caption.c_str(),CHECK_UNIXSTYLE->Checked,!CHECK_INCLUDEMAIN->Checked);
  return false;
}
//---------------------------------------------------------------------------
void __fastcall TdlgCodeSettings::Button1Click(TObject *Sender)
{
  // set file button - set file name, and warn if extension not 'normal'
  while (1)
  {
    if (!SaveDialog1->Execute())
      break;
    Label1->Caption=SaveDialog1->FileName;
    RADIO_USEFILE->Checked=true;
    // check if .c/.cpp file
    char path[260]="";
    strcpy(path,Label1->Caption.c_str());
    int len=strlen(path);
    if ( len>4 && ( 0==stricmp(&path[len-2],".c") || 0==stricmp(&path[len-4],".cpp") ) )
      break; // passed
    if (IDYES==::MessageBox(Handle,"You have selected a non-source file (.C/.CPP) "
                                "- is this what you want?","Select File",MB_YESNO) )
        break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TdlgCodeSettings::Button2Click(TObject *Sender)
{
  // ok button pressed - check and continue proecessing only if filename set
  if ( RADIO_USEFILE->Checked && 0==strlen(Label1->Caption.c_str()) )
  {
    MessageBox(Handle,"Destination filename not set","Error",MB_OK);
    ModalResult=mrNone;
  }
}
//---------------------------------------------------------------------------

