#ifndef objarrayH
#define objarrayH
/*===========================================================================


       formgrp.h -    handler for all objects on a form

                      Copyright  2001, 2003 by Pankhurst Algorithmics
                      (www.pankhurst.com, www.ebmDevMag.com)
                      All Rights Reserved


===========================================================================*/
class CBaseObject;
//---------------------------------------------------------------------------
class CFormGroup
{

  private:

    // output file header, for version identification
    struct s_fileHeader
    {
      long versionMain;
      long versionType;
      long id;
      long totalEntry;
    };

    const unsigned int c_maxObj; // capacity

    CBaseObject **m_obj; // object list array
    int m_totalObj;      // amount

    bool m_dirty;        // has file changed?

    void Clear(void);

    CBaseObject *ReadEntry(HANDLE hFile);
    void DefaultHeader(s_fileHeader*hdr,int totalEntry);
    int  ExportFile(char *ptr,
                    const char *fileName,
                    bool unixLinefeeds,
                    bool outputHeader,
                    bool outputMain,
                    bool outputClass,
                    bool outputCode );
    bool ReadString(HANDLE handle,char **ptrIn);
    bool ReNew(char**ptrIn,unsigned int oldCopyLen,unsigned int newLen);
    bool WriteString(HANDLE handle,const char *ptr);

  public:

    char *m_directivesText, *m_classText; // text portions output with the code

    CFormGroup(unsigned int maxArray,const char *formName,int x,int y,int dx,int dy);
    ~CFormGroup(void);
    CBaseObject*Object(unsigned int index);
    bool Add(CBaseObject*object,int x,int y,int dx,int dy);
    bool Add(CBaseObject*object);
    void Delete(unsigned int index);
    bool Load(const char *file);
    bool Save(const char *file);
    bool OutputCPPSourceCode(const char *file,bool unixLinefeeds,bool excludeMain);
    int  TotalObj(void)
    {   return m_totalObj;  }
    bool Dirty(void)
    {  return m_dirty;      }
    void SetDirtyFlag(void)
    {  m_dirty=true;        }
    void Swap(int a,int b);

};
//---------------------------------------------------------------------------
#endif
