/*===========================================================================


       x
       Copyright  2001 Pankhurst Algorithmics - All Rights Reserved


===========================================================================*/
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>
#include <Grids.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
//---------------------------------------------------------------------------
class TBackPanel : public TForm
{

  __published:	// IDE-managed Components

    TPanel *WORKSPACE_BACK;
    TMainMenu *MainMenu1;
    TPanel *PANEL_PROPERTIES;
    TMenuItem *File1;
    TMenuItem *Help1;
    TMenuItem *menuHelp;
    TMenuItem *N2;
    TMenuItem *About1;
    TMenuItem *NewForm1;
    TMenuItem *N6;
    TMenuItem *LoadForm1;
    TMenuItem *Save1;
    TMenuItem *SaveAs1;
    TMenuItem *N9;
    TMenuItem *Exit1;
    TPanel *WORKSPACE;
    TSpeedButton *SpeedButton1;
    TSpeedButton *SpeedButton2;
    TSpeedButton *SpeedButton3;
    TSpeedButton *SpeedButton4;
    TSpeedButton *SpeedButton5;
    TSpeedButton *SpeedButton6;
    TShape *WORKSPACE_OUTLINE;
    TStringGrid *GRID_PROPERTIES;
    TLabel *Label1;
    TMenuItem *N4;
    TMenuItem *ExportCode1;
    TLabel *LABEL_CURROBJ;
    TPaintBox *DISPLAY_CANVAS;
    TMenuItem *View1;
    TMenuItem *Display1;
    TMenuItem *NormalSize1;
    TMenuItem *N2x1;
    TMenuItem *N3x1;
    TMenuItem *N4x1;
    TMenuItem *Edit1;
    TMenuItem *Grid1;
    TMenuItem *UseGrid1;
    TSaveDialog *SaveDialog1;
    TSpeedButton *SpeedButton7;
    TSpeedButton *SpeedButton8;
    TSpeedButton *SpeedButton9;
    TSpeedButton *SpeedButton10;
    TSpeedButton *SpeedButton11;
    TSpeedButton *SpeedButton12;
    TSpeedButton *SpeedButton13;
    TSpeedButton *SpeedButton14;
    TSpeedButton *SpeedButton16;
    TSpeedButton *SpeedButton17;
    TMenuItem *N1;
    TMenuItem *LockForm1;
    TMenuItem *N3;
    TMenuItem *DeleteItem1;
    TOpenDialog *OpenDialog1;
    TMenuItem *N5;
    TMenuItem *MovetoBack1;
    TMenuItem *SendtoFront1;
    TMenuItem *Source;
    TMenuItem *Directives1;
    TMenuItem *Source1;
    TMenuItem *N7;
    TMenuItem *QuickUpdate1;
    TStatusBar *StatusBar1;
    void __fastcall FormCanResize(TObject *Sender, int &NewWidth, int &NewHeight, bool &Resize);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall DISPLAY_CANVASPaint(TObject *Sender);
    void __fastcall About1Click(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall NormalSize1Click(TObject *Sender);
    void __fastcall WORKSPACEMouseDown(TObject *Sender,  TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall WORKSPACEMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
    void __fastcall WORKSPACEMouseUp(TObject *Sender,  TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall Grid1Click(TObject *Sender);
    void __fastcall UseGrid1Click(TObject *Sender);
    void __fastcall GRID_PROPERTIESSelectCell(TObject *Sender, int ACol, int ARow, bool &CanSelect);
    void __fastcall GRID_PROPERTIESKeyPress(TObject *Sender, char &Key);
    void __fastcall LockForm1Click(TObject *Sender);
    void __fastcall DeleteItem1Click(TObject *Sender);
    void __fastcall GRID_PROPERTIESDblClick(TObject *Sender);
    void __fastcall Save1Click(TObject *Sender);
    void __fastcall LoadForm1Click(TObject *Sender);
    void __fastcall NewForm1Click(TObject *Sender);
    void __fastcall SaveAs1Click(TObject *Sender);
    void __fastcall ExportCode1Click(TObject *Sender);
    void __fastcall MovetoBack1Click(TObject *Sender);
    void __fastcall SendtoFront1Click(TObject *Sender);
    void __fastcall menuHelpClick(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall Directives1Click(TObject *Sender);
    void __fastcall Source1Click(TObject *Sender);
    void __fastcall QuickUpdate1Click(TObject *Sender);

  private:	// User declarations

    enum  {  c_maxObj=210,  };

    CFormGroup *m_obj;

    int m_displayDX, m_displayDY;
    int m_scale;

    TImage *m_image;

    int m_grid;

    int m_formLeftDX, m_formTopDY;
    int m_formOffsetX, m_formOffsetY;

    enum e_dragSection
    {
      DRAG_UNDEFINED=0,
      DRAG_LEFT,
      DRAG_TOP,
      DRAG_RIGHT,
      DRAG_BOTTOM,
      DRAG_CENTER,
    } m_mouseDragSection;

    bool m_mouseDown;
    int  m_mouseDownX, m_mouseDownY;
    int  m_mouseOverIndex;
    int  m_selectedIndex;
    RECT m_selRect;

    char m_file[260];

    void CheckOrientation(void);
    void AdjustComponents(void);
    int  GetNewObject(int x,int y);
    int  GetSelectedObject(int x,int y);
    void SyncPropertiesToObject(void);
    void DrawDisplay(void);
    void AdjustDisplaySize(int newScale);
    void HandleGridEntry(void);
    void ExportFile(char *ptr);
    void NameObject(int index);
    bool NeedToSave(void);
    void ObjToScreenPos(int *xPos,int *yPos,int index);
    void AdjustFormPosition(void);
    void DrawStatus(void);
    bool SaveWithBackup(const char *filename);

  public:		// User declarations

    __fastcall TBackPanel(TComponent* Owner);
    __fastcall ~TBackPanel(void);


};
//---------------------------------------------------------------------------
extern PACKAGE TBackPanel *BackPanel;
//---------------------------------------------------------------------------
#endif
